package com.tzld.piaoquan.longarticle.service.impl;

import com.tzld.piaoquan.longarticle.model.bo.*;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortRequest;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortResponse;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortResponseData;
import com.tzld.piaoquan.longarticle.model.dto.PublishArticleData;
import com.tzld.piaoquan.longarticle.model.po.CrawlerVideo;
import com.tzld.piaoquan.longarticle.model.po.LongArticlesText;
import com.tzld.piaoquan.longarticle.model.vo.*;
import com.tzld.piaoquan.longarticle.service.CoreService;
import com.tzld.piaoquan.longarticle.utils.TimeZoneUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

@Service
public class CoreServiceImpl implements CoreService {

    @Autowired
    private PlanServiceImpl planService;

    @Autowired
    private SortServiceImpl sortService;

    @Autowired
    private ContentServiceImpl contentService;

    @Autowired
    private PublishServiceImpl publishService;

    @Autowired
    private KimiServiceImpl kimiService;

    @Autowired
    private CardServiceImpl cardService;

    @Autowired
    private CoverServiceImpl coverService;

    public void core() {
        List<PlanAccount> planAccounts = new ArrayList<>();

        List<LongArticleSystemPlan> allLongArticleSystemPlans = planService.getAllLongArticleSystemPlan();
//        for (LongArticleSystemPlan longArticleSystemPlan : allLongArticleSystemPlans) {
//            //获取排序策略
//            Map<String, String> sortStgMap = new HashMap<>();
//            List<GzhArticleSortTaskParam> gzhArticleSortTask = longArticleSystemPlan.getGzhArticleSortTask();
//            for (GzhArticleSortTaskParam gzhArticleSortTaskParam : gzhArticleSortTask) {
//                String strategy = gzhArticleSortTaskParam.getStrategy();
//                List<String> accountIds = gzhArticleSortTaskParam.getAccountIds();
//                for (String accountId : accountIds) {
//                    sortStgMap.put(accountId, strategy);
//                }
//            }
//            //获取小程序策略
//            Map<String, MiniprogramInsertTaskParam> miniStgMap = new HashMap<>();
//            List<MiniprogramInsertTaskParam> miniprogramInsertTasks = longArticleSystemPlan.getMiniprogramInsertTasks();
//            for (MiniprogramInsertTaskParam miniprogramInsertTaskParam : miniprogramInsertTasks) {
//                List<String> accountIds = miniprogramInsertTaskParam.getAccountIds();
//                for (String accountId : accountIds) {
//                    miniStgMap.put(accountId, miniprogramInsertTaskParam);
//                }
//            }
//            for (LongArticleSystemPlanAccount account : longArticleSystemPlan.getAccountList()) {
//                PlanAccount planAccount = new PlanAccount();
//                String accountId = account.getId();
//                planAccount.setPlanId(longArticleSystemPlan.getId());
//                planAccount.setPlanName(longArticleSystemPlan.getName());
//                planAccount.setAccountId(accountId);
//                planAccount.setAccountName(account.getName());
//                planAccount.setGzhId(account.getGzhId());
//                planAccount.setPublishNum(longArticleSystemPlan.getPublishNum());
//                planAccount.setPublishPerMinNum(longArticleSystemPlan.getPublishPerMinNum());
//                planAccount.setPublishPushTime(longArticleSystemPlan.getPublishPushTime());
//                MiniprogramInsertTaskParam miniprogramInsertTaskParam = miniStgMap.get(accountId);
//                if (miniprogramInsertTaskParam != null) {
//                    planAccount.setMiniprogramUseType(miniprogramInsertTaskParam.getMiniprogramUseType());
//                    planAccount.setMiniStrategy(miniprogramInsertTaskParam.getStrategy());
//                } else {
//                    planAccount.setMiniprogramUseType(1);
//                    planAccount.setMiniStrategy("strategy_v1");
//                }
//                if (sortStgMap.containsKey(accountId)) {
//                    planAccount.setSortStrategy(sortStgMap.get(accountId));
//                } else {
//                    planAccount.setSortStrategy("ArticleRankV1");
//                }
//                planAccount.setPushType(longArticleSystemPlan.getPushType());
//                planAccounts.add(planAccount);
//            }
//        }

//        for (PlanAccount planAccount : planAccounts) {
//            LongArticleSystemGetContentsParam param = new LongArticleSystemGetContentsParam();
//            param.setAccountId(param.getAccountId());
//            param.setPlanId(planAccount.getPlanId());
//            LongArticleSystemContentVO longArticleSystemContentVO = planService.listWaitingMatchMiniprogramContents(param);
//            //TODO 调用匹配接口
//
//            //TODO 匹配成功后  通知AIGC
//
//        }

        PlanAccount planAccount1 = new PlanAccount();
        planAccount1.setAccountId("20231208111728193795195");
        planAccount1.setAccountName("票圈大事件");
        planAccount1.setGzhId("gh_9e559b3b94ca");
        planAccount1.setPlanId("20241012140830436890740");
        planAccount1.setPublishNum(8);
        planAccount1.setMiniStrategy("strategy_v1");
        planAccount1.setSortStrategy("ArticleRankV5");
        planAccount1.setPublishPerMinNum(4);
        planAccount1.setMiniprogramUseType(1);
        planAccount1.setPushType(2);
        planAccounts.add(planAccount1);


        for (PlanAccount planAccount : planAccounts) {
            ArticleSortRequest articleSortRequest = new ArticleSortRequest();
            articleSortRequest.setAccountId(planAccount.getAccountId());
            articleSortRequest.setAccountName(planAccount.getAccountName());
            articleSortRequest.setGhId(planAccount.getGzhId());
            articleSortRequest.setStrategy(planAccount.getSortStrategy());
            articleSortRequest.setPublishNum(planAccount.getPublishNum());
            articleSortRequest.setPlanId(planAccount.getPlanId());
            articleSortRequest.setPushType(planAccount.getPushType());

            ArticleSortResponse articleSortResponse = sortService.publishArticleSort(articleSortRequest);
            ArticleSortResponseData data = articleSortResponse.getData();
            if (data == null || CollectionUtils.isEmpty(data.getRank_list())) {
                continue;
            }
            if (!CollectionUtils.isEmpty(data.getFilter_list())) {
                List<FilterSortContentParam> list = new ArrayList<>();
                for (PublishArticleData publishArticleData : data.getFilter_list()) {
                    FilterSortContentParam param = new FilterSortContentParam();
                    param.setFilterReason(publishArticleData.getFilterReason());
                    param.setPublishContentId(publishArticleData.getId());
                    list.add(param);
                }
                FilterSortParam param = new FilterSortParam();
                param.setFilterSortContentList(list);
                planService.filterSortContents(param);
            }
            List<LongArticleSystemPushContentParam> pushContentList = new ArrayList<>();
            //排序结束
            List<PublishArticleData> rankList = data.getRank_list();
            for (PublishArticleData publishArticleData : rankList) {
                LongArticleSystemPushContentParam contentParam = new LongArticleSystemPushContentParam();
                String publishContentId = publishArticleData.getId();
                List<CrawlerVideo> contentVideos =
                        contentService.getContentVideo(publishArticleData.getSourceId(), publishArticleData.getContentPoolType(), planAccount.getGzhId());
                List<VideoDetail> videoDetails = new ArrayList<>();
                for (CrawlerVideo crawlerVideo : contentVideos) {
                    String videoOssPath = crawlerVideo.getVideoOssPath();
                    String platform = crawlerVideo.getPlatform();
                    String userId = crawlerVideo.getUserId();
                    String traceId = crawlerVideo.getTraceId();
                    String kimiTitle;
                    LongArticlesText kimiText = kimiService.getKimiText(crawlerVideo.getContentId());
                    if (kimiText != null && StringUtils.isNotEmpty(kimiText.getKimiTitle())) {
                        kimiTitle = kimiText.getKimiTitle();
                    } else {
                        kimiTitle = crawlerVideo.getVideoTitle();
                    }
                    VideoDetail publish = publishService.publish(videoOssPath, userId, kimiTitle, platform, traceId);
                    if (publish == null) {
                        continue;
                    }
                    videoDetails.add(publish);
                }
                if (videoDetails.size() < 2) {
                    continue;
                }
                String gzhId = planAccount.getGzhId();
                List<PublishMiniprogram> cardList = cardService.generateCards(gzhId, videoDetails, planAccount.getMiniprogramUseType(), publishContentId);
                if (CollectionUtils.isEmpty(cardList)) {
                    continue;
                }
                contentParam.setPublishContentId(publishContentId);
                contentParam.setMiniprogramCardList(cardList);
                pushContentList.add(contentParam);
            }
            LongArticleSystemCreatePushTaskParam gzhPushParam = new LongArticleSystemCreatePushTaskParam();
            gzhPushParam.setPlanId(planAccount.getPlanId());
            gzhPushParam.setAccountId(planAccount.getAccountId());
            gzhPushParam.setPushType(planAccount.getPushType());
            gzhPushParam.setPushScheduleTimestamp(System.currentTimeMillis());
            if (StringUtils.isNotEmpty(planAccount.getPublishPushTime())) {
                String dateTimeStr = TimeZoneUtil.todayYMD(TimeZoneUtil.Timezone.china) + " " + planAccount.getPublishPushTime();
                gzhPushParam.setPushScheduleTimestamp(TimeZoneUtil.getDateStrTimestamp(dateTimeStr, "yyyy-MM-dd HH:mm:ss", TimeZoneUtil.Timezone.china));
            } else {
                gzhPushParam.setPushScheduleTimestamp(System.currentTimeMillis());
            }
            gzhPushParam.setPushContentList(pushContentList);
            if (pushContentList.size() < planAccount.getPublishPerMinNum()) {
                //TODO 数量不足
            }
            planService.createPushTask(gzhPushParam);
        }

    }
}
