package com.tzld.piaoquan.longarticle.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.longarticle.service.CoverService;
import com.tzld.piaoquan.longarticle.utils.HttpClientUtil;
import com.tzld.piaoquan.longarticle.utils.HttpPoolClientUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class CoverServiceImpl implements CoverService {

    private static final HttpPoolClientUtil HTTP_POOL_CLIENT_UTIL_DEFAULT = HttpClientUtil.create(5000, 5000, 20, 100, 3, 3000);


    public String pushCover(String coverUrl, String publishContentId) {
        String apiUrl = "http://aigc-testapi.cybertogether.net/aigc//publish/LongArticleSystem/uploadMiniprogramCover";
        try {
            JSONObject param = new JSONObject();
            param.put("coverUrl", coverUrl);
            param.put("publishContentId", publishContentId);
            String res = HTTP_POOL_CLIENT_UTIL_DEFAULT.post(apiUrl, JSONObject.toJSONString(param));
            JSONObject jsonObject = JSON.parseObject(res);
            Integer code = jsonObject.getInteger("code");
            if (code == 0) {
                JSONObject data = jsonObject.getJSONObject("data");
                return data.getString("wxUrl");
            }
            return null;
        } catch (Exception e) {
            log.error("getAllLongArticleSystemPlan error", e);
        }
        return null;
    }
}
