package com.tzld.piaoquan.longarticle.service.impl;

import com.tzld.piaoquan.longarticle.dao.mapper.LongArticlesTextMapper;
import com.tzld.piaoquan.longarticle.model.po.LongArticlesText;
import com.tzld.piaoquan.longarticle.model.po.LongArticlesTextExample;
import com.tzld.piaoquan.longarticle.service.KimiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Service
public class KimiServiceImpl implements KimiService {

    @Autowired
    LongArticlesTextMapper longArticlesTextMapper;

    @Override
    public void addContent(String contentId, String articleTitle, String articleText) {

        LongArticlesTextExample example = new LongArticlesTextExample();
        example.createCriteria().andContentIdEqualTo(contentId);
        long l = longArticlesTextMapper.countByExample(example);
        if (l == 0) {
            LongArticlesText longArticlesText = new LongArticlesText();
            longArticlesText.setContentId(contentId);
            longArticlesText.setArticleTitle(articleTitle);
            longArticlesText.setArticleText(articleText);
            longArticlesText.setKimiStatus(0);
            longArticlesTextMapper.insertSelective(longArticlesText);
        }
        longArticlesTextMapper.selectByExample(example);

    }

    @Override
    public LongArticlesText getKimiText(String contentId) {
        LongArticlesTextExample example = new LongArticlesTextExample();
        example.createCriteria().andContentIdEqualTo(contentId);
        List<LongArticlesText> longArticlesTexts = longArticlesTextMapper.selectByExample(example);
        if(CollectionUtils.isEmpty(longArticlesTexts)){
            return null;
        }
        return longArticlesTexts.get(0);
    }
}
