package com.tzld.piaoquan.longarticle.service.impl;


import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortRequest;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortResponse;
import com.tzld.piaoquan.longarticle.utils.HttpClientUtil;
import com.tzld.piaoquan.longarticle.utils.HttpPoolClientUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.Objects;

@Slf4j
@Service
public class SortServiceImpl {

    private static final HttpPoolClientUtil HTTP_POOL_CLIENT_UTIL_DEFAULT = HttpClientUtil.create(5000, 200000, 20, 100, 3, 3000);

    public ArticleSortResponse publishArticleSort(ArticleSortRequest request) {
        ArticleSortResponse response = new ArticleSortResponse();
        String apiUrl = "http://101.37.174.139:80/recommend";
        int retryTimes = 2;
        while (retryTimes > 0) {
            try {
                retryTimes--;
                log.info("publishArticleSort,request:{}", JSON.toJSONString(request));
                String res = HTTP_POOL_CLIENT_UTIL_DEFAULT.post(apiUrl, JSON.toJSONString(request));
                log.info("publishArticleSort recommend Api返回数据:{}", res);

                response = JSON.parseObject(res, ArticleSortResponse.class);
                if (Objects.nonNull(response) && Objects.nonNull(response.getData())) {
                    response.setSuccessful(true);
                    if (CollectionUtil.isNotEmpty(response.getData().getRank_list())) {
                        break;
                    }
                }
            } catch (Exception e) {
                log.error("publishArticleSort recommend response parseObject", e);
            }
        }
        return response;
    }

}
